#ifndef DRAW_HPP
#define DRAW_HPP

#include <string>
#include <iostream>
#include "SDL_GLM_INCLUDES.hpp"

using glm::vec3;

class N_Graphics {
public:
	static void die_with_sdl_error(std::string message);
	static void die_if_opengl_error();
	static SDL_Window* createWindow(std::string title, int width, int height);
	static void destroyWindow(SDL_Window *window);
	static VertexBuffer allocateVertexBuffer(int size);
	static ElementBuffer allocateElementBuffer(int size);
	static void copyVertexData(VertexBuffer buffer, void *data, int size);
	static void copyElementData(ElementBuffer buffer, void *data, int size);
	static void setVertexArray(VertexBuffer buffer);
	static void setColorArray(VertexBuffer buffer);
	static void setNormalArray(VertexBuffer buffer);
	static void setTexCoordArray(VertexBuffer buffer);
	static void drawElements(GLenum mode, ElementBuffer buffer, int count);
	static Texture loadTexture(std::string bmpFile);
	static void setTexture(Texture texture);
	static void unsetTexture();
};

#endif
